local ADDON, Package = ...

local Color = Package.Color

local Module = {}

function Module.configure_to_sell_junk()
  local ticker = nil

  local worker = function (args)
    local pending = false

    args.items = args.items or 0
    args.price = args.price or 0

    for bag_id = 0, NUM_BAG_SLOTS do
      for slot_id = 1, GetContainerNumSlots(bag_id) do
        local item_id = GetContainerItemID(bag_id, slot_id)

        if item_id then
          local _, item_count, item_locked, item_quality = GetContainerItemInfo(bag_id, slot_id)
          local _, _, _, _, _, _, _, _, _, _, item_sell_price = GetItemInfo(item_id)

          if not item_locked and item_quality == 0 and item_sell_price > 0 and MerchantFrame:IsShown() then
            UseContainerItem(bag_id, slot_id)

            pending = true

            args.items = args.items + 1
            args.price = args.price + (item_count * item_sell_price)
          end
        end
      end
    end

    if not pending and not ticker:IsCancelled() or not MerchantFrame:IsShown() then
      if args.items > 0 and args.price > 0 then
        DEFAULT_CHAT_FRAME:AddMessage(
          ITEM_QUALITY_COLORS[0].color:WrapTextInColorCode(ITEM_QUALITY0_DESC .. "x" .. args.items) .. " " ..
          GetCoinTextureString(args.price):gsub(":0", ":-8")
        )
      end

      ticker:Cancel()
    end
  end

  local f = function ()
    if ticker then
      ticker:Cancel()
    end

    ticker = C_Timer.NewTicker(0.2, worker, 20)
  end

  local agent = CreateFrame("Frame")
  agent:SetScript("OnEvent", function (self, event, ...)
    if not IsShiftKeyDown() then
      f()
    end
  end)
  agent:RegisterEvent("MERCHANT_SHOW")
end

function Module.configure_to_repair_equips()
  local f = function ()
    local repair_all_cost, can_repair = GetRepairAllCost()

    if can_repair and GetMoney() >= repair_all_cost then
      RepairAllItems()

      DEFAULT_CHAT_FRAME:AddMessage(Color.YELLOW:WrapTextInColorCode(REPAIR_ALL_ITEMS) .. " " .. GetCoinTextureString(repair_all_cost):gsub(":0", ":-8"))
    end
  end

  local agent = CreateFrame("Frame")
  agent:SetScript("OnEvent", function (self, event, ...)
    if not IsShiftKeyDown() then
      f()
    end
  end)
  agent:RegisterEvent("MERCHANT_SHOW")
end

Package.Merchant = Module
